# Key Ceremony

Keys and, therefore, identities are managed on both node types

1. Energy Agents
2. Validator Nodes

## Energy Agents

Energy Agents come with a pre-attested MachineID that enables them to start interacting with the RDDL Network. The MachineID comes as a part of the firmware or is defined with an attached crypto-chip.&#x20;

The keys used to interact with Liquid and Planetmint are created via a key ceremony on the Energy Agents.

The key ceremony includes the creation of the following identities:&#x20;

* a keypair to interact on the Liquid network
* a keypair to interact on Planetmint
  * a derived address on Planetmint

RDDL Network lets machines participate as soon as they attest themselves as part of the [Installation](/rddl-network/getting-started/the-energyagent/installation.md). Within the process of the machine attestation, the public keys of the machine on Liquid, Planetmint, the Planetmint address and the Machine ID are attested and associated with each other.&#x20;

It is possible to look up and verify if a given public key, address or machine ID belongs to the same machine as another given public key, address or machine ID.&#x20;

The API calls

[/github.com/planetmint/planetmint-go/machine/get\_machine\_by\_public\_key/{publicKey}](https://planetmint-go-testnet-api.rddl.io/github.com/planetmint/planetmint-go/machine/get_machine_by_public_key)

[/github.com/planetmint/planetmint-go/machine/get\_trust\_anchor\_status/{machineid}](https://planetmint-go-testnet-api.rddl.io/github.com/planetmint/planetmint-go/machine/get_trust_anchor_status/)

can be used for this purpose.

## Validator Nodes

Coming soon.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rddl.io/rddl-network/basics/types-of-nodes/key-ceremony.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
